/*!
 * @danielhaim/autotoc - v1.1.0 - 2024-01-25
 * git+https://github.com/danielhaim1/autotoc.git
 * Copyright (c) 2024 Daniel Haim, Licensed MIT
 */(()=>{"use strict";var t={497:(t,e,i)=>{var o;const n={Generate:i(352).Generate};t.exports&&(t.exports=n),void 0===(o=function(){return n}.apply(e,[]))||(t.exports=o),"object"==typeof window&&(window.AutoToc=n)},352:(t,e,i)=>{Object.defineProperty(e,"__esModule",{value:!0}),e.Generate=void 0;(o=i(864))&&o.__esModule;var o,n=i(896);e.Generate=class{constructor(t,e,i,o,n,r){this.contentSelector=t,this.navigationContainer=e,this.tocTitle=i,this.tocIcon=o,this.highlightOffset=n,this.headingDepthLimit=r,this.tocMap=new Map,this.tocTopMap=new Map,this.tocBottomMap=new Map,this.pendingExternalLinks=[]}validateParameters(){if("string"!=typeof this.contentSelector||!document.querySelector(this.contentSelector))throw new Error("Invalid contentSelector: Must be a valid CSS selector string for an existing element.");if("string"!=typeof this.navigationContainer||!document.querySelector(this.navigationContainer))throw new Error("Invalid navigationContainer: Must be a valid CSS selector string for an existing element.");if("string"!=typeof this.tocTitle)throw new Error("Invalid tocTitle: Must be a string.");if(null!==this.tocIcon&&"string"!=typeof this.tocIcon&&void 0!==this.tocIcon)throw new Error("Invalid tocIcon: Must be a string or null.");if("number"!=typeof this.highlightOffset||this.highlightOffset<0)throw new Error("Invalid highlightOffset: Must be a non-negative number.");if("number"!=typeof this.headingDepthLimit||this.headingDepthLimit<1||this.headingDepthLimit>6||!Number.isInteger(this.headingDepthLimit))throw new Error("Invalid headingDepthLimit: Must be an integer between 1 and 6.")}detachEventListeners(){window.removeEventListener("scroll",this.boundScrollListener)}generateUniqueId(t){return(new n.slugify).generate(t.textContent||"")}populateTocMap(){const t=Array.from({length:this.headingDepthLimit},((t,e)=>`${this.contentSelector} h${e+1}`)),e=document.querySelectorAll(t),i=new Map;e.forEach((t=>{const e=parseInt(t.tagName.charAt(1)),o=t.id,n=t.textContent.trim();this.tocMap.has(o)||i.set(o,{level:e,text:n})})),this.tocMap=new Map([...this.tocMap,...i]),this.renderTocHtml()}createTocList(t){const e=document.createElement("ol");return t.forEach(((t,i)=>{const{level:o,text:n}=t,r=n.replace(/^#/,""),s=document.createElement("li");s.className=`toc-list--item level-${o}`,s.setAttribute("role","listitem");const a=document.createElement("a");a.href=`#${i}`,a.textContent=r,s.appendChild(a),e.appendChild(s)})),e}renderTocHtml(){const t=document.createElement("ol");t.className="toc-list",t.setAttribute("role","list");let e=[t],i=1;const o=this.createTocList(this.tocTopMap),n=this.createTocList(this.tocBottomMap);this.pendingExternalLinks.forEach((t=>{const i=document.createElement("li");i.className="toc-list--item level-level-0",i.setAttribute("role","listitem");const o=document.createElement("a");o.href=`#${t.id}`,o.textContent=t.text,i.appendChild(o),e[e.length-1].appendChild(i)})),this.tocMap.forEach(((t,o)=>{const{level:n,text:r}=t,s=n-i;if(s>0)for(let t=0;t<s;t++){const t=document.createElement("ol");e[e.length-1].lastElementChild.appendChild(t),e.push(t)}else if(s<0)for(let t=0;t<-s;t++)e.pop();const a=r.replace(/^#/,""),l=document.createElement("li");l.className=`toc-list--item level-${n}`,l.setAttribute("role","listitem");const c=document.createElement("a");c.href=`#${o}`,c.textContent=a,l.appendChild(c),e[e.length-1].appendChild(l),i=n}));const r=document.querySelector(this.navigationContainer);r&&(r.innerHTML=`<header><h2>${this.tocIcon}<span>${this.tocTitle}</span></h2></header>`,r.appendChild(o),r.appendChild(t),r.appendChild(n),r.setAttribute("role","doc-toc"),r.addEventListener("click",(t=>{if("A"===t.target.tagName&&t.target.getAttribute("href")){t.preventDefault();const e=t.target.getAttribute("href").substring(1);this.scrollToElement(e)}})))}attachAnchorsToHeadings(){const t=this.createHeadingSelector();document.querySelectorAll(`${this.contentSelector} ${t}`).forEach((t=>{const e=this.generateUniqueId(t);t.id=e;const i=document.createElement("a");i.href=`#${e}`,i.textContent="#",t.insertBefore(i,t.firstChild)}))}createHeadingSelector(){return Array.from({length:this.headingDepthLimit},((t,e)=>`h${e+1}`)).join(", ")}scrollToElement(t){const e=document.getElementById(t);if(e){this.highlightOffset;const t=e.offsetTop-window.innerHeight/2+e.clientHeight/2;window.scrollTo({top:t,behavior:"smooth"})}}highlightActiveSection(){const t=this.highlightOffset,e=this.createHeadingSelector(),i=document.querySelectorAll(e);i.forEach(((e,o)=>{const n=e.getAttribute("id"),r=document.querySelector(`${this.navigationContainer} .toc-list--item a[href="#${n}"]`),s=i[o+1],a=window.pageYOffset>=e.offsetTop-t,l=!!s&&window.pageYOffset>=s.offsetTop-t;r&&(a&&!l?r.classList.add("active"):r.classList.remove("active"))}))}addContentToToc(t,e,i){this.tocMap.has(e)||(this.tocMap.set(e,{level:t,text:i}),this.renderTocHtml())}addExternalLinksToToc(t,e="bottom",i="level-0"){if(!Array.isArray(t))throw new Error("Invalid links: Must be an array of link objects.");"top"===e?t.forEach((t=>{if("object"!=typeof t||!t.id||!t.text)throw new Error("Invalid link format: Each link object must have 'id' and 'text' properties.");this.tocTopMap.has(t.id)||this.tocTopMap.set(t.id,{level:i,text:t.text})})):t.forEach((t=>{if("object"!=typeof t||!t.id||!t.text)throw new Error("Invalid link format: Each link object must have 'id' and 'text' properties.");this.tocBottomMap.has(t.id)||this.tocBottomMap.set(t.id,{level:i,text:t.text})})),this.renderTocHtml()}initializeScrollHighlighting(){this.boundHighlightActiveSection=this.highlightActiveSection.bind(this);const t=modulate(this.boundHighlightActiveSection,200);window.addEventListener("scroll",t)}initialize(){this.validateParameters(),this.attachAnchorsToHeadings(),this.populateTocMap(),this.renderTocHtml(),this.initializeScrollHighlighting()}}},864:t=>{t.exports=require("@danielhaim/modulator")},896:t=>{t.exports=require("@danielhaim/slugify/src/index.js")}},e={};var i=function i(o){var n=e[o];if(void 0!==n)return n.exports;var r=e[o]={exports:{}};return t[o](r,r.exports,i),r.exports}(497);module.exports=i})();